<?php

include("ecrire/inc_version.php3");

function not_found() {
	http_status(404);
	exit;
}

$uri = $REQUEST_URI;
$referer=$HTTP_REFERER;

if (ereg(lire_meta("adresse_site"),$referer)){
	
	if (!ereg("/IMG/",$uri) || !ereg("..",$uri)){
		not_found();
	}

	$fichier = preg_replace(",^.*/IMG/,", "IMG/", $uri);
	if (!@file_exists($fichier) || !@is_file($fichier)){
		not_found();
	}
	
		
	$size = @filesize($fichier);
	if (!$size){
			not_found();
	}
	
	
	$if_modified_since = ereg_replace(';.*$', '', $HTTP_IF_MODIFIED_SINCE);
	$gmoddate = gmdate("D, d M Y H:i:s", @filemtime($fichier))." GMT";
	if ($if_modified_since == $gmoddate) {
		http_status(304);
		exit;
	}
	http_status(200);
	
	$nom=ereg_replace(".*/","",$fichier);
	$extension=ereg_replace("^(.*)\.(.*)$", "\\2", $nom);
	$req= "SELECT mime_type FROM spip_types_documents WHERE extension='".$extension."'";
	$res = spip_query($req);
	if (spip_num_rows($res)>0){
		$row = spip_fetch_array($res);
		$mimeType = $row['mime_type'];
		Header('Content-Type: '.$mimeType);
	}

	Header("Content-Length: ".$size);
	Header("Last-Modified: ".$gmoddate);	
	Header('Content-Disposition: attachment; filename="'.$nom.'"');
	
	readfile($fichier);
}
else {
	not_found();
}


?>
